//funcion que tiene la responsabilidad de ordenar aleatoriamente un arreglo
function shuffle(a) {
   var array = a.slice(0);
   var currentIndex = array.length,
      temporaryValue, randomIndex;
   // While there remain elements to shuffle...
   while (0 !== currentIndex) {
      // Pick a remaining element...
      randomIndex = Math.floor(Math.random() * currentIndex);
      currentIndex -= 1;
      // And swap it with the current element.
      temporaryValue = array[currentIndex];
      array[currentIndex] = array[randomIndex];
      array[randomIndex] = temporaryValue;
   }
   return array;
}

$(document).ready(inicio);
//Propiedades
var exito = false;
var puntaje = 50;
var idBotonCalificar = "#edModal__calificar";
var idModal = ".modalCalificacion";
var botonCerrar = ".js-edModal__cerrar";

function inicio() {

   //$(idBotonCalificar).on("click", mostrarCalificacion);
   $(botonCerrar).on("click", reInit);

   $('.js-redi__btnCerrar').off('click');
   $('.js-redi__btnCerrar').on('click', cerrarRedi);
}

//funcion que tiene la responsabilidad de mostrar el modal de calificacion
function mostrarModalCalificacion() {
   //console.log('ya mero luego pasa esto');
   /*puntaje = puntaje.toFixed();
   if (puntaje == 100) {
      exito = true;
   }*/
   puntaje = 0;
   puntaje = ($("#completar-a3 .correcto").size() / ($("#completar-a3 select").size())) * 100;
   console.log($("#completar-a3 .correcto").size());
   puntaje = puntaje.toFixed(0);
   console.log(puntaje);
   exito = false;
   var mensaje = "Inténtalo nuevamente."

   if (puntaje == 100) {
      exito = true;
      mensaje = "¡Felicitaciones!"
   }
   mostrarCalificacion(idModal, puntaje + '%', exito, reInit);

   var outline = (puntaje * 1830) / 100;
   $('.outline').attr('style', 'stroke: rgb(1 109 56); stroke-width: 40px;stroke-dasharray: ' + outline + ', 1830;stroke-dashoffset: 0;');
}

//Funcion que la responsabilidad mostrar en un modal la calificación obtenida en la actividad
function mostrarCalificacion(idModal, puntaje, exito, reInit) {

   //console.log('se llamo el modal');
   $(idModal).find('.puntaje').text(puntaje);
   //console.log('puntaje ', $(idModal).find('.puntaje'));
   //Si es exitoso se muestra el boton cerrar de lo contrario el boton intentar nuevamente.
   if (exito) {
      //console.log('entro a exito cerrar');
      $(idModal).find('.modalCalificacion__boton').html(' ');
      $(idModal).find('.mensaje').html('Felicitaciones!');
      $(idModal).find('.modalCalificacion__boton').html('Cerrar');
      $(idModal).find('.modalCalificacion__boton').on('click', cerrarRedi);
   } else {
      //console.log('entro a exito volver');
      $(idModal).find('.modalCalificacion__boton').html(' ');
      $(idModal).find('.mensaje').html('Volver a intentar');
      $(idModal).find('.modalCalificacion__boton').html('Volver a intentar');
      $(idModal).find('.modalCalificacion__boton').on('click', reInit);
   }
   setTimeout(function () {
      $('.js-edModal').removeClass('edModal--activo');
      $('.js-edModal').addClass('edModal--activo');
      $('body').css('overflow', 'hidden');
   }, 100);

}

function cerrarRedi() {
   var data = {
      'cerrarRedi': 'cerrar',
   };
   window.parent.postMessage(data, '*');
   console.log('Mensaje cerrarRedi enviado');
}

//funcion que tiene la responsabilidad de reiniciar el REDI

function reInit() {

   //funcion responsable de cerrar el modal
   $("#completar-a3 .cs-select.incorrecto .cs-placeholder").html("");
   $("#completar-a3 .cs-select.incorrecto select").val("");
   $("#completar-a3 .cs-select.incorrecto").removeClass('incorrecto correcto');
   var outline = 0;
   $('.outline').removeAttr('style', 'stroke: rgba(184,0,0,0.8); stroke-width: 40px;stroke-dasharray: ' + outline + ', 1830;stroke-dashoffset: 0;');

   $('.js-edModal').removeClass('edModal--activo');
   $('body').css('overflow', 'initial');

}